import React, { useRef, useState, useEffect } from "react";
import Button from '@mui/material/Button';
import { getCookie } from 'react-use-cookie';
import { DataGrid, GridToolbar, frFR } from '@mui/x-data-grid';
import axios from "axios";
import Box from '@mui/material/Box';
import InputLabel from '@mui/material/InputLabel';
import InputAdornment from '@mui/material/InputAdornment';
import FormControl from '@mui/material/FormControl';
import TextField from '@mui/material/TextField';
import AccountCircle from '@mui/icons-material/AccountCircle';
import PhoneIcon from '@mui/icons-material/Phone'
import EmailIcon from '@mui/icons-material/Email'
import HomeIcon from '@mui/icons-material/Home'
import { useHistory } from "react-router-dom";
import OrderConfirmation from "./OrderConfirmation";
import { IoAddCircleOutline } from "react-icons/io5";
import MyPaymentMethode from "./PaymentMethode";
import img_visa_mastercard from "./../mysy_img/visa_mastercard.png"
import img_logo_stripe from "./../mysy_img/logo-stripe-secure.png";
import img_loading_spin from "./../mysy_img/mysy_spin_loading.gif";
import img_paypal from "./../mysy_img/paypal.png"
import moment from "moment";
import {
    CardElement,
    useStripe,
    useElements,
} from '@stripe/react-stripe-js';
import { Elements } from '@stripe/react-stripe-js';
import { loadStripe } from '@stripe/stripe-js';
import { PaymentElement } from '@stripe/react-stripe-js';
import Popup from 'reactjs-popup';
import SendIcon from '@mui/icons-material/Send';

const stripePromise = loadStripe('pk_test_51LUUfAAbmaEugrFTI25uZBD3IFjbtaL6jUfRV83diDf7nco8worna4NGKhMHbPP71WCwT5EHFRdDNatxPrJWwgZ300kgH5EO4p');
//const stripePromise_PROD = loadStripe('pk_live_51LUUfAAbmaEugrFTyfNe4Dj0vbxc5qXQqNs0rztjAKy8oSlc5EEQyJGjA8Z5kXmP2gvUMcYLUBYCIyWWzLCw59RY00PtGInkVf');



function HebergementLms(props) {

    const [myApiResponse, setmyApiResponse] = useState("");
    const [result, setResult] = useState("");
    const [menu, setmenu] = useState("default");
    const [fields1desabled, setfields1desabled] = useState(true);
    const [periode, setperiode] = useState("Mensuel");
    const [testval, settestval] = useState();
    const [gotocheckout, setgotocheckout] = useState("0");
    const [currentpack, setcurrentpack] = useState(props.packs);
    const [periodicity, setperiodicity] = useState(props.periodicity);
    const [packprice, setpackprice] = useState(props.mypackprice);
    const [getpackproducts, setgetpackproducts] = useState();
    const scrollDiv = useRef(null);
    const [okcommande, setokcommande] = useState();
    const stripe = useStripe();
    const elements = useElements();


    // recuperation et gestion  du token utilisateur 
    const history = useHistory();
    const stored_part = getCookie('tokenmysypart');
    if (!stored_part || stored_part.length <= 0) {
        history.push("/PartnerLogin");
    }


    const [GetLms_Themes_api, setGetLms_Themes_api] = useState();
    const [GetLms_Themes_message, setGetLms_Themes_message] = useState();
    const [GetLms_Themes_result, setGetLms_Themes_result] = useState();
    function GetLms_Themes(event) {

        var form = new FormData();

        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Lms_Themes/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === "true") {
                //console.log(" In GetLms_Themes  res.data.status = " + res.data.status);
                //console.log(" In GetLms_Themes  res.data.message r_class = " + res.data.message);
                setGetLms_Themes_api("true");
                setGetLms_Themes_result(res.data.message);
            }
            else {
                setGetLms_Themes_api("false");
                setGetLms_Themes_message(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( GetLms_Themes = ', error);
            setGetLms_Themes_api("false");

        })
    }

    const [RecordData_api, setRecordData_api] = useState();
    const [RecordData_result, setRecordData_result] = useState();
    const [RecordData_message, setRecordData_message] = useState();

    function RecordData() {
        var form = new FormData();

        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append('theme_name', selected_lms_theme_text);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Lms_Config_Theme_and_Logo/";
        setLoading(true);
        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === "true") {
                //console.log(" In GetLms_Themes  res.data.status = " + res.data.status);
                //console.log(" In GetLms_Themes  res.data.message r_class = " + res.data.message);
                setRecordData_api("true");
                setRecordData_result(res.data.message);
                setLoading(false);
            }
            else {
                setRecordData_api("false");
                setRecordData_message(res.data.message);
                setLoading(false);
            }

        }).catch((error) => {
            console.warn('Not good man :( GetLms_Themes = ', error);
            setRecordData_api("false");
            setLoading(false);

        })
    }


    const [selected_lms_theme, setselected_lms_theme] = useState();
    const [selected_lms_theme_text, setselected_lms_theme_text] = useState();
    const [urlpreview_lms_theme, seturlpreview_lms_theme] = useState();
    function handleChangeselected_lms_theme(event) {

        var val = event.target.value
        GetLms_Themes(val)
        seturlpreview_lms_theme(val);

        const sel = document.getElementById("lms_theme_liste");
        let value = sel.options[sel.selectedIndex].value;
        let text = sel.options[sel.selectedIndex].text;
        setselected_lms_theme_text(text)

    }


    useEffect(() => {
        GetLms_Themes();
    }, [])

    const [isLoading, setLoading] = useState();
    const [formation_file_name, setformation_file_name] = useState();
    const hiddenFileInput_formation = React.useRef(null);
    const [handleSubmission_api, sethandleSubmission_api] = useState();
    const [handleSubmission_result, sethandleSubmission_result] = useState();
    const [handleSubmission_message, sethandleSubmission_message] = useState();


    const [img_logo_file, setimg_logo_file] = useState();

    const handleSubmission = event => {

        const fileUploaded = event.target.files[0];
        let file_size = event.target.files[0].size;
        let file_type = event.target.files[0].type;

        //console.log("file_size =  ",file_size," file_type = ",file_type);
        if (file_size > 1000000) {
            alert("Le fichier ne doit pas depasser un 1 Méga octets");
            return;
        }

        setformation_file_name(event.target.files[0].name);
        setimg_logo_file(URL.createObjectURL(event.target.files[0]));

    };


    const changeHandler2 = (event) => {
        hiddenFileInput_formation.current.click();
    };


    return (
        <div className="hebergementlms">

            {isLoading && <div className="loader-container">
                <div className="mysy_spinner">  <img src={img_loading_spin} />  </div>
            </div>}



            {String(menu) === String("default") && <div>
                <h2 style={{ "textAlign": "center", "marginBottom": "2rem" }} ref={scrollDiv}> Espace de parametrage de l'environnement d'hébergement</h2>

                <br />
            </div>}

            {String(RecordData_api) === "true" && <div className="okUpdateData"> la mise à jour a été correctement faite</div>}

            {String(RecordData_api) === "false" && <div className="koUpdateData"> {RecordData_message}</div>}

            <div className="session_caract">Choisir un exemple de thème : <br />

                <select id="lms_theme_liste" name="lms_theme_liste" value={selected_lms_theme} onChange={handleChangeselected_lms_theme} className="selectsession">
                    <option value="">Choisir un modèle </option>
                    {GetLms_Themes_result &&
                        GetLms_Themes_result.map((lms_theme) => (
                            <option value={JSON.parse(lms_theme).template_preview_url}>
                                {JSON.parse(lms_theme).nom_template}

                            </option>
                        ))}
                </select>

            </div>

            <div className="session_caract">Le modèle d'attestation :
                <img className="preview_certif" src={urlpreview_lms_theme} />
            </div>

            <div className="div_row">
                <div className="div_row" style={{ "border": "None" }}>
                    &nbsp;
                </div>
                {<div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                    <div className="div_row_gauche " style={{ "textAlign": 'left', 'marginLeft': '15px' }}>
                        <Button variant="contained" className="btn_modif" onClick={"One_annuleSessionUpdate"}>Annuler
                        </Button>
                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                        <Button variant="contained" className="btn_enreg" onClick={RecordData}>Enregistrer
                        </Button>


                    </div>

                </div>}
                <div className="div_row" style={{ "border": "None" }}>
                    &nbsp;
                </div>

            </div>

            <div className="div_row"> Import du background <br />
                <div className="div_row" style={{ "border": "None" }}>
                    &nbsp;
                </div>
                <Button variant="outlined" onClick={changeHandler2} className="detail_class_submenu" style={{
                    "background": "#c8cfd5",
                    "minWidth": "15rem", "color": "black", "width": "auto"
                }}
                    id='menu_import_formation' name='menu_import_formation'>Choisir une image  &nbsp; <br />
                    <i> (Le logo doit être de taille 250 x 70 px et au format PNG) </i>
                </Button><br />
                {formation_file_name && <nav className="okUpdateData"><i>{formation_file_name}</i></nav>}
                <input type="file"
                    accept=".png"
                    ref={hiddenFileInput_formation}
                    style={{ display: 'none' }}
                    name="liste_formation_file"
                    onChange={handleSubmission}
                />

                {img_logo_file && <nav> Fichier à importer : {img_logo_file.name}  <br />
                <img src={img_logo_file} alt={""}/>
               
                  <br />
                </nav>}

                <br />

                <div className="div_row">
                <div className="div_row" style={{ "border": "None" }}>
                    &nbsp;
                </div>
                {<div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                    <div className="div_row_gauche " style={{ "textAlign": 'left', 'marginLeft': '15px' }}>
                        <Button variant="contained" className="btn_modif" onClick={"One_annuleSessionUpdate"}>Annuler le logo
                        </Button>
                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                        <Button variant="contained" className="btn_enreg" onClick={"RecordData"}>Enregistrer le logo
                        </Button>


                    </div>

                </div>}
                <div className="div_row" style={{ "border": "None" }}>
                    &nbsp;
                </div>

            </div>
            </div>

        </div>);

}

export default HebergementLms;